{program rxSerialChallenger
sends serial strings at either 57600 or 115200 baud for testing the program rxSerial
Note this is in spin, so there is extra stop time between each byte transmitted (amounting to about 2 stop bits at 115.2kbaud)
Use logic analyzer or 'scope to probe timings.
}
CON
  _CLKMODE = XTAL1  + PLL16X
  _XINFREQ = 5_000_000

  serpin = 1       ' serial output on this pin at either 57600 or 115200 baud, stop bit high
  modepin = 4     ' if this pin is high, transmit at 115200 baud, or low, transmit at 57600 baud
                  ' baud rate mode can be changed on the fly at run time

VAR
  long   stack[32], delay, baud
    byte state

OBJ
  fds : "fullduplexserial"

PUB main
  state := !ina[modepin]
  repeat
    if state <> ina[modepin]
      if ina[4]==0
        baud := 57600
      else
        baud := 115200
    fds.start(serpin,0,0,baud)
    pause(200)
    fds.str(string("Use this time slot to send a packet of data at "))
    fds.dec(baud)
    fds.str(string(" baud to prop #2, which should receive it perfectly but with low current drain.",13))
    pause(1000)


PRI pause(ms)
  waitcnt(clkfreq/1000*ms + cnt)


