{program rxSerialDemo.spin
author: Tracy Allen, EME Systems
Demo of rxSerial_ta_10
rxSerial_ta_10 is a receive only uart, motivated by a need for low power operation at up to 115200 baud even with clkfreq=5MHz.
At higher clkfreq, correspondingly higher baud rates possible.
This demo uses fullDuplexSerial at low baud rate to retransmit received data to a PC terminal for verification.
A rxSerialChallenger program is included in the archive, meant to send data from a second prop at the high baud rate.

--current drain, rxSerial + fullDuplexSerial (3 cogs active):
      xtal1   1.1 mA       5 MHz
      + PLL2x  2.6mA    10 MHz
      + PLL4x	4.6mA   20 MHz
      + PLL8x  8.5 mA   40 MHz
      + PLL16x   16 mA  80 MHz
}

CON
  _CLKMODE = XTAL1     '  + pll2x
  _XINFREQ = 5_000_000

  mypin = 15       ' main serial burst input
  baud = 115200

VAR
  long   stack[32]
  byte char

OBJ
  fds : "fullduplexserial"
  rx: "rxSerial_ta_10"
  challenger: "rxSerialChallenger"  ' this should be run on another prop, included here for archiving

PUB main
  outa[0..27]~                  ' peg all unused pins
  dira[0..27]~~
  dira[mypin]~                  ' serial receive from 2nd source
  rx.start(mypin,0,baud)
  fds.start(31,30,0,2400)       ' for debug output
  pause(200)
  fds.str(string(13,"bitticks= "))  ' show the time allowed per bit, in prop clock ticks.
  fds.dec(clkfreq/baud)
  fds.tx(13)

  repeat                        ' receive and transmit
    char := rx.rx
    fds.tx(char)


PRI pause(ms)
  waitcnt(clkfreq/1000*ms + cnt)

